﻿Imports System.ServiceModel

Namespace Contract
    <ServiceContract>
    Public Interface IExpenseApproval
        ' request approval for a purchase. Returns the purchaseId
        <OperationContract>
        Function RequestApproval(ByVal employeeId As String, ByVal description As String, ByVal amount As Double) As Integer

        ' manager approval for a purchase operation (purchaseId should be used as correlation key)
        <OperationContract>
        Sub ManagerApproval(ByVal purchaseId As Integer, ByVal approved As Boolean, ByVal comments As String)
    End Interface
End Namespace