﻿Imports System.Activities

' activities to be used for waiting for events in the StateMachine
Public Class WaitForBookmark
    Inherits NativeActivity
    Public Property BookmarkName As InArgument(Of String)

    Protected Overrides ReadOnly Property CanInduceIdle As Boolean
        Get
            Return True
        End Get
    End Property

    Protected Overrides Sub Execute(ByVal context As NativeActivityContext)
        context.CreateBookmark(Me.BookmarkName.Get(context))
    End Sub
End Class

Public Class WriteLineWithColor
    Inherits CodeActivity
    Public Property Text As InArgument(Of String)

    Public Property Color As InArgument(Of ConsoleColor)

    Protected Overrides Sub Execute(ByVal context As CodeActivityContext)
        Dim previous As ConsoleColor = Console.ForegroundColor
        Console.ForegroundColor = Me.Color.Get(context)
        Console.WriteLine(Me.Text.Get(context))
        Console.ForegroundColor = previous
    End Sub
End Class