﻿Imports System.Activities
Imports System.ComponentModel
Imports System.Text

Namespace Microsoft.Samples.Activities

    Public Class WaitForInput(Of T)
        Inherits NativeActivity(Of T)

        <System.ComponentModel.DefaultValue("")>
        Public Property BookmarkName As String

        Protected Overrides ReadOnly Property CanInduceIdle As Boolean
            Get
                Return True
            End Get
        End Property

        Protected Overrides Sub Execute(ByVal context As NativeActivityContext)
            context.CreateBookmark(Me.BookmarkName, AddressOf [Continue])
        End Sub

        Private Sub [Continue](ByVal context As NativeActivityContext, ByVal bookmark As Bookmark, ByVal state As Object)
            Result.Set(context, state)
        End Sub
    End Class

End Namespace
